import type { Env, Target } from './types';
type FilenameGetter = string | ((code?: string) => string);
type FilepathGetter = string | ((filename: string) => string);
export type OutputOptions = {
    cssFilename: FilenameGetter;
    cssFilepath: FilepathGetter;
};
export declare class Output {
    env: Env;
    config: OutputOptions;
    filepath: string;
    cacheDir: string;
    constructor({ env, config }: {
        env: Env;
        config?: Partial<OutputOptions>;
    });
    private resolveFilepath;
    save({ sourceMap, filenameRelative, target, }: {
        sourceMap: string;
        filenameRelative: string;
        target: Target;
    }): {
        importName: string;
    };
}
export {};
