import { findBindings } from './findBindings.js';

function getPathsByBindings(bindings) {
    const paths = new Set();
    for (const x of bindings.keys()) {
        if (x.path.isImportSpecifier() || x.path.isVariableDeclarator()) {
            paths.add(x.path.parentPath);
            continue;
        }
        paths.add(x.path);
    }
    return paths;
}
function buildCodeByPath(path) {
    return Array.from(getPathsByBindings(findBindings(path, { throwError: true })))
        .sort((a, b) => a.node.start - b.node.start)
        .map((x) => x.toString())
        .join('\n');
}

export { buildCodeByPath };
//# sourceMappingURL=buildCodeByPath.js.map
