import * as t from '@babel/types';

function mergeObjectProperties(properties) {
    const map = new Map();
    function move(key, value) {
        map.delete(key);
        map.set(key, value);
    }
    for (const x of properties) {
        if (!t.isObjectProperty(x)) {
            move(x, x);
            continue;
        }
        const { key } = x;
        if (t.isIdentifier(key)) {
            move(key.name, x);
            continue;
        }
        if (t.isStringLiteral(key)) {
            move(key.value, x);
            continue;
        }
        move(x, x);
    }
    // TODO: there was a problem with typescript compiler with the variant [...map.values()]
    return Array.from(map.values());
}
function mergeObjects(objects) {
    const properties = [];
    objects.forEach((obj) => {
        properties.push(...obj.properties);
    });
    return mergeObjectProperties(properties);
}

export { mergeObjectProperties, mergeObjects };
//# sourceMappingURL=mergeObjectProperties.js.map
