'use strict';

var t = require('@babel/types');
var core = require('@taddy/core');
var getObjectPropertyKey = require('./getObjectPropertyKey.cjs');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceDefault(t);

function apply(quasis) {
    let expr;
    let curr = '';
    for (const v of quasis) {
        if (typeof v === 'string') {
            curr += (curr ? ' ' : '') + v;
            continue;
        }
        if (expr && curr) {
            expr = t__namespace.binaryExpression('+', expr, t__namespace.stringLiteral(' ' + curr + ' '));
            expr = t__namespace.binaryExpression('+', expr, v);
        }
        else if (curr) {
            expr = t__namespace.binaryExpression('+', t__namespace.stringLiteral(curr + ' '), v);
        }
        else {
            expr = v;
        }
        curr = '';
    }
    if (expr && curr) {
        expr = t__namespace.binaryExpression('+', expr, t__namespace.stringLiteral(' ' + curr));
    }
    return expr || t__namespace.stringLiteral(curr);
}
function optimizeStaticStyles(path) {
    // const quasis: string[] = [];
    // const expressions: any[] = [];
    const props = [];
    let quasis = [];
    for (const propPath of path.get('properties')) {
        if (!propPath.isObjectProperty()) {
            throw new Error('Cant optimize this path');
        }
        const keyPath = propPath.get('key');
        const key = getObjectPropertyKey.getObjectPropertyKey(keyPath);
        if (!key)
            return;
        const valuePath = propPath.get('value');
        if (key === 'className' || key === 'style' || key === core.VARS_KEY) {
            if (quasis.length) {
                props.push(t__namespace.objectProperty(apply(quasis), t__namespace.booleanLiteral(true)));
            }
            props.push(propPath.node);
            quasis = [];
            continue;
        }
        // if (key === 'className') {
        //     quasis.push(valuePath.node);
        //     continue;
        // }
        if (valuePath.isStringLiteral()) {
            quasis.push(key + valuePath.node.value);
            continue;
        }
        if (valuePath.isBooleanLiteral()) {
            quasis.push(key);
            continue;
        }
        quasis.push(t__namespace.binaryExpression('+', t__namespace.stringLiteral(key), valuePath.node));
        // expressions.push(
        //     t.binaryExpression(
        //         '+',
        //         t.stringLiteral(key),
        //         valuePath.node as t.Expression,
        //     ),
        // );
    }
    if (props.length === 0) {
        path.replaceWith(apply(quasis));
        return;
    }
    if (quasis.length) {
        props.push(t__namespace.objectProperty(apply(quasis), t__namespace.booleanLiteral(true)));
    }
    path.node.properties = props;
}

exports.optimizeStaticStyles = optimizeStaticStyles;
//# sourceMappingURL=optimizeStaticStyles.cjs.map
